# extconf for Corporate Time
#
# $Id: extconf.rb,v 1.13 2005/02/09 01:12:08 ianmacd Exp $

require 'mkmf'
require 'rbconfig'

dir_config('capi')

unless have_header('ctapi.h')
  $stderr.puts <<EOF
If ctapi.h is on your system, ensure that CAPI_FUNC is defined, using
something like this:

#define CAPI_FUNC(a) a
EOF
  exit 1
end

unless have_library('capi', 'CAPI_Connect')
  exit 1
end

# check for version 2.5 or later of CAPI API
have_func('CAPI_AuthenticateAsSysop', 'ctapi.h')

# check for the version 9 from Oracle
have_func('CSDK_Connect', 'ctapi.h')

create_makefile('ctime')

File.open('Makefile', 'a') do |f|
  f.print <<EOF

extra-clean:	distclean
		-rm -f $(docfiles)

docfiles	= doc/ctime.html doc/corptime.3

docs:		$(docfiles)

doc/ctime.html:	doc/ctime.rd
		rd2 doc/ctime.rd > doc/ctime.html

doc/corptime.3:	doc/ctime.rd
		rd2 -rrd/rd2man-lib.rb doc/ctime.rd > doc/corptime.3
		ruby -i -pe 'gsub!(/ctime 1/, "ctime 3")' doc/corptime.3
EOF
end

# Avoid exporting all symbols, which avoids some conflicts between symbols
# in Oracle's CAPI and our own CAPI layer. We don't know how to do this with
# compilers other than gcc, so we stick to that.
if CONFIG["CC"] == "gcc"
  mklines = IO.readlines('Makefile')
  mkfile = File.open('Makefile', 'w')
  mklines.each do |line|
    if line =~ /^LDSHARED =/
      mkfile.print(line.chomp + " -Xlinker --version-script=exports.map\n")
    else
      mkfile.print(line)
    end
  end
end
