# $Id: setup.rb,v 1.2 2005/04/14 17:41:06 ianmacd Exp $

require 'ctime'
require 'test/unit'


DEFAULT_PORT = 5730

# read ~/.mycal if it exists
DOT_MYCAL = ENV['HOME'] + '/.mycal'

EXTRA_USERS = %w[ wold ghowland duff ]

class TC_CTimeTest < Test::Unit::TestCase

  def setup
    server = nil; line_nr = __LINE__
    user = nil
    passwd = nil

    if FileTest.readable?( DOT_MYCAL )
      File.open( DOT_MYCAL ) do |file|
        while line = file.gets
          eval line
        end
      end
    end
    
    if server.nil?
      $stderr.puts "Please define a CorporateTime server in either line " +
		   "#{line_nr} of this program or a ~/.mycal file."
      exit 1
    end
    
    server.sub!( /:?$/, ':' + DEFAULT_PORT.to_s ) unless server =~ /:\d+/
    user ||= ( print "Username: "; gets.chomp ) 

    begin
      require 'password'
    rescue LoadError
      $stderr.puts "This program requires Ruby/Password: http://www.caliban.org/ruby/"
      raise
    end

    passwd ||= Password.getc( "Calendar password: " )

    @@ct = CTime.new.connect( server, user, passwd )
    @@user = user
  end

  def teardown
    @@ct.quit
  end

  undef_method :default_test

end


if FileTest.readable?( DOT_MYCAL )
  if File.stat( DOT_MYCAL ).mode & 2 == 2
    $stderr.printf( "%s is writable by others. Please fix this.\n", dot_mycal )
    exit 1
  end
end


